PROGRAM Dump2PICT;

	{ Dump/QRT <-> PICT file conversion utility, version 1.0 }

	USES
		Desk, Dialogs, Errors, Events, Files, Fonts, Memory, Menus, OSEvents,
		OSUtils, Packages, QuickDraw, QuickDraw32Bit, Resources, ToolUtils, Types;
	
	CONST
		numMenus	= 3;
		
		appleMenu	= 1;
		aboutItem	= 1;
		
		fileMenu	= 2;
		d2pItem		= 1;
		p2dItem		= 2;
		quitItem	= 4;
		
		editMenu	= 3;
	
	TYPE
		DLine = ARRAY[0..0] OF SignedByte;
		DLinePtr = ^DLine;
		PLine = ARRAY[0..0] OF RECORD a, r, g, b: SignedByte END;
		PLinePtr = ^PLine;
		OSTypePtr = ^OSType;
		OSTypeHandle = ^OSTypePtr;
		
	VAR
		myMenus:				ARRAY[1..3] OF MenuHandle;
		myEvent:				EventRecord;
		myGDevice:				GDHandle;
		watch:					Cursor;
		dummyB, mf_available:	BOOLEAN;
		PICT_File:				INTEGER;
		PICT_Size:				LONGINT;
		PICT_Handle:			PicHandle;
		picFileCreator:			OSType;
		err, spoolErr:			OSErr;
	
	FUNCTION TrapAvailable(trapNum: INTEGER): BOOLEAN;
	BEGIN
		TrapAvailable:= NGetTrapAddress(trapNum, ToolTrap)
								<> NGetTrapAddress($A89F, ToolTrap)
	END;
		
	PROCEDURE Initialize;
		VAR
			i, dummyI:	INTEGER;
			theWorld:	SysEnvRec;
			dummyB:		BOOLEAN;
			h:			Handle;
			ctH:		CTabHandle;
			cH:			CursHandle;
	BEGIN
		{ Initialize toolbox. }
		InitGraf(@thePort);
		InitFonts;
		FlushEvents(everyEvent, 0);
		InitWindows;
		InitDialogs(NIL);
		TEInit;
		InitCursor;
		SetCursor(arrow);
		
		{ Can I run? }
		FOR i:= 1 TO 3 DO
			dummyB:= GetNextEvent(everyEvent, myEvent);
		IF (SysEnvirons(1, theWorld) <> noErr) | (theWorld.systemVersion < $0605)
			| (NOT theWorld.hasColorQD) | (NOT TrapAvailable($AB03)) THEN
			BEGIN
				dummyI:= StopAlert(129, NIL);
				ExitToShell
			END;
		
		{ Set up menus. }
		FOR i:= 1 TO numMenus DO
			myMenus[i]:= GetMenu(i + 127);
		AddResMenu(myMenus[appleMenu], 'DRVR');
		FOR i:= 1 TO numMenus DO
			InsertMenu(myMenus[i], 0);
		DrawMenuBar;
		
		{ Initialize GDevice, needed for drawing into off-screen PixMap. }
		ctH:= CTabHandle(NewHandle(SIZEOF(ColorTable)));
		WITH ctH^^ DO
			BEGIN
				ctSeed:= 24;
				ctFlags:= $8000;
				ctSize:= 0
			END;
		myGDevice:= NewGDevice(0, -1);
		WITH myGDevice^^ DO
			BEGIN
				gdID:= 0;
				gdType:= directType;
				WITH gdPMap^^ DO
					BEGIN
						DisposCTable(pmTable);
						pmTable:= ctH;
						pmVersion:= 0;
						packType:= 0;
						packSize:= 0;
						pixelType:= RGBDirect;
						pixelSize:= 32;
						cmpCount:= 3;
						cmpSize:= 8;
						planeBytes:= 0;
						pmReserved:= 0
					END;
				gdSearchProc:= NIL;
				gdCompProc:= NIL;
				gdFlags:= $C001;
				gdNextGD:= NIL;
				gdReserved:= 0
			END;
		
		{ Other miscellaneous initializations. }
		mf_available:= TrapAvailable($A88F);
		h:= GetResource('crea', 128);
		picFileCreator:= OSTypeHandle(h)^^;
		ReleaseResource(h);
		cH:= GetCursor(watchCursor);
		watch:= cH^^;
		ReleaseResource(Handle(cH))
	END;
	
	FUNCTION SwapBytes(wrd: INTEGER): INTEGER;
	INLINE $301F, $1200, $E048, $E141, $1200, $3E81;
	{
		Swap bytes of a word.
		
		move.w     (sp)+,d0
		move.b     d0,d1
		lsr.w      #8,d0
		asl.w      #8,d1
		move.b     d0,d1
		move.w     d1,(a7)
	}
	
	FUNCTION ReadWord(refNum: INTEGER; VAR wrd: INTEGER): OSErr;
		VAR
			count: LONGINT;
	BEGIN
		{ Read LSB-first word from file. }
		count:= 2;
		err:= FSRead(refNum, count, @wrd);
		IF err = noErr THEN
			wrd:= SwapBytes(wrd);
		ReadWord:= err
	END;
	
	FUNCTION WriteWord(refNum, wrd: INTEGER): OSErr;
		VAR
			count: LONGINT;
	BEGIN
		{ Write LSB-first word to file. }
		count:= 2;
		wrd:= SwapBytes(wrd);
		WriteWord:= FSWrite(refNum, count, @wrd)
	END;
	
	FUNCTION DPNewHandle(s: Size): Handle;
		TYPE
			LongPtr = ^LONGINT;
		VAR
			h: Handle;
			p: LongPtr;
			i: LONGINT;
	BEGIN
		{ Get new locked handle, using MF Temp memory if possible. }
		IF mf_available THEN
			BEGIN
				h:= MFTempNewHandle(s, err);
				IF err = noErr THEN
					MFTempHLock(h, err)
				ELSE
					h:= NIL
			END
		ELSE
			BEGIN
				h:= NewHandle(s);
				IF h <> NIL THEN
					BEGIN
						MoveHHi(h);
						HLock(h)
					END
			END;
		{ Fill block with $FF. That is, erase it to all white. }
		IF h <> NIL THEN
			BEGIN
				p:= LongPtr(h^);
				FOR i:= 1 TO s DIV 4 DO
					BEGIN
						p^:= -1;
						p:= LongPtr(LONGINT(p) + 4)
					END
			END;
		DPNewHandle:= h
	END;
	
	PROCEDURE DPDisposHandle(h: Handle);
	BEGIN
		{ Dispose locked handle allocated by DPNewHandle. }
		IF mf_available THEN
			BEGIN
				MFTempHUnlock(h, err);
				MFTempDisposHandle(h, err)
			END
		ELSE
			BEGIN
				HUnlock(h);
				DisposHandle(h)
			END
	END;
	
	PROCEDURE PutPICTData(dataPtr: Ptr; byteCount: INTEGER);
		VAR
			longCount: LONGINT;
	BEGIN
		longCount:= byteCount;
		PICT_Size:= PICT_Size + byteCount;
		err:= FSWrite(PICT_File, longCount, dataPtr);
		IF PICT_Handle <> NIL THEN
			PICT_Handle^^.picSize:= PICT_Size;
		IF (err <> noErr) AND (spoolErr = noErr) THEN
			spoolErr:= err
	END;

	PROCEDURE DumpToPICT;
		VAR
			where:						Point;
			list:						SFTypeList;
			reply:						SFReply;
			s, srcName, dstName:		Str255;
			i, srcVol, dstVol, dFile:	INTEGER;
			width, height, line:		INTEGER;
			srcDir, dstDir, count:		LONGINT;
			dummyL:						LONGINT;
			pixdata:					Ptr;
			pixdata_h:					Handle;
			r_buf, g_buf, b_buf:		DLinePtr;
			addr:						PLinePtr;
			bm:							BitMap;
			pm:							PixMapHandle;
			savePix:					Ptr;
			ct:							CTabHandle;
			savePort:					GrafPtr;
			myPort:						CGrafPort;
			myProcs:					CQDProcs;
	BEGIN
		{ Get source and destination filenames, vRefNums and dirIDs. }
		where.h:= 100;
		where.v:= 100;
		SFGetFile(where, '', NIL, -1, list, NIL, reply);
		IF NOT reply.good THEN
			EXIT(DumpToPICT);
		srcName:= reply.fName;
		err:= GetWDInfo(reply.vRefNum, srcVol, srcDir, dummyL);
		
		GetIndString(s, 128, 1);
		i:= length(reply.fName);
		IF (i > 4) & EqualString(copy(reply.fName, i - 3, 4), '.dis', FALSE, TRUE) THEN
			delete(reply.fName, i - 3, 4);
		SFPutFile(where, s, reply.fName, NIL, reply);
		IF NOT reply.good THEN
			EXIT(DumpToPICT);
		dstName:= reply.fName;
		err:= GetWDInfo(reply.vRefNum, dstVol, dstDir, dummyL);
		SetCursor(watch);
		
		{ Get image size and allocate pixmap and line buffers. }
		IF HOpen(srcVol, srcDir, srcName, fsRdPerm, dFile) <> noErr THEN
			BEGIN
				SysBeep(10);
				SetCursor(arrow);
				EXIT(DumpToPICT)
			END;
		err:= ReadWord(dFile, width);
		err:= ReadWord(dFile, height);
		pixdata_h:= DPNewHandle(LONGINT(width) * height * 4);
		IF pixdata_h = NIL THEN
			BEGIN
				err:= FSClose(dFile);
				SysBeep(10);
				SetCursor(arrow);
				EXIT(DumpToPICT)
			END;
		pixdata:= pixdata_h^;
		r_buf:= DLinePtr(NewPtr(width));
		g_buf:= DLinePtr(NewPtr(width));
		b_buf:= DLinePtr(NewPtr(width));
		
		{ Read lines and put them into pixmap. }
		WHILE (ReadWord(dFile, line) = noErr) & (line >= 0) & (line < height) DO
			BEGIN
				count:= width;
				err:= FSRead(dFile, count, Ptr(r_buf));
				count:= width;
				err:= FSRead(dFile, count, Ptr(g_buf));
				count:= width;
				err:= FSRead(dFile, count, Ptr(b_buf));
				addr:= PLinePtr(LONGINT(pixdata) + LONGINT(width) * 4 * line);
				{$PUSH}
				{$R-}
				FOR i:= 0 TO width - 1 DO
					WITH addr^[i] DO
						BEGIN
							a:= 0;
							r:= r_buf^[i];
							g:= g_buf^[i];
							b:= b_buf^[i]
						END
				{$POP}
			END;
		
		{ Clean up buffers for reading Dump file; close Dump file. }
		DisposPtr(Ptr(r_buf));
		DisposPtr(Ptr(g_buf));
		DisposPtr(Ptr(b_buf));
		err:= FSClose(dFile);
		
		{ Set up QuickDraw PixMap data structure. }
		pm:= NewPixMap;
		DisposCTable(pm^^.pmTable);
		ct:= CTabHandle(NewHandle(SIZEOF(ColorTable)));
		WITH ct^^ DO
			BEGIN
				ctSeed:= 24;
				ctFlags:= 0;
				ctSize:= 0
			END;
		WITH pm^^ DO
			BEGIN
				pmTable:= ct;
				savePix:= baseAddr;
				baseAddr:= pixdata;
				rowBytes:= BOR(LONGINT(width) * 4, $8000);
				SetRect(bounds, 0, 0, width, height);
				pmVersion:= 0;
				packType:= 0;
				packSize:= 0;
				pixelType:= RGBDirect;
				pixelSize:= 32;
				cmpCount:= 3;
				cmpSize:= 8;
				planeBytes:= 0;
				pmReserved:= 0
			END;
		bm.baseAddr:= Ptr(pm);
		bm.rowBytes:= $C000;
		
		{ Create, open & prepare PICT file. }
		err:= HDelete(dstVol, dstDir, dstName);
		err:= HCreate(dstVol, dstDir, dstName, picFileCreator, 'PICT');
		err:= HOpen(dstVol, dstDir, dstName, fsWrPerm, PICT_File);
		IF err <> noErr THEN
			BEGIN
				DPDisposHandle(pixdata_h);
				SysBeep(10);
				SetCursor(arrow);
				EXIT(DumpToPICT)
			END;
		FOR i:= 0 TO 255 + SIZEOF(Picture) DIV 2 DO
			err:= WriteWord(PICT_File, 0);
		
		{ Set up picture spooling. }
		GetPort(savePort);
		OpenCPort(@myPort);
		SetPort(@myPort);
		SetStdCProcs(myProcs);
		myPort.grafProcs:= @myProcs;
		myProcs.putPicProc:= @PutPICTData;
		PICT_Size:= SIZEOF(Picture);
		ClipRect(pm^^.bounds);
		PICT_Handle:= OpenPicture(pm^^.bounds);
		
		{ Spool! }
		spoolErr:= noErr;
		CopyBits(bm, thePort^.portBits, pm^^.bounds, pm^^.bounds, ditherCopy, NIL);
		
		{ That was easy, eh? Now, clean up. }
		ClosePicture;
		err:= GetEOF(PICT_File, count);
		IF (spoolErr = noErr) AND (count = PICT_Size + 512) THEN
			BEGIN
				err:= SetFPos(PICT_File, fsFromStart, 512);
				count := SIZEOF(Picture);
				HLock(Handle(PICT_Handle));
				err:= FSWrite(PICT_File, count, Ptr(PICT_Handle^));
				HUnlock(Handle(PICT_Handle));
				err:= FSClose(PICT_File)
			END
		ELSE
			BEGIN
				{ Writing PICT file failed. Alert user with a beep. }
				err:= FSClose(PICT_File);
				err:= HDelete(dstVol, dstDir, dstName);
				SysBeep(10)
			END;
		KillPicture(PICT_Handle);
		DPDisposHandle(pixdata_h);
		pm^^.baseAddr:= savePix;
		DisposPixMap(pm);
		SetPort(savePort);
		SetCursor(arrow)
	END;
	
	PROCEDURE GetPICTData(dataPtr: Ptr; byteCount: INTEGER);
		VAR
			longCount: LONGINT;
	BEGIN
		longCount:= byteCount;
		err:= FSRead(PICT_File, longCount, dataPtr);
		IF (err <> noErr) AND (spoolErr = noErr) THEN
			spoolErr:= err
	END;

	PROCEDURE PICTToDump;
		VAR
			where:						Point;
			list:						SFTypeList;
			reply:						SFReply;
			s, srcName, dstName:		Str255;
			i, srcVol, dstVol, dFile:	INTEGER;
			width, height, line:		INTEGER;
			srcDir, dstDir, count:		LONGINT;
			dummyL, len1, len2:			LONGINT;
			picBounds:					Rect;
			pixdata:					Ptr;
			pixdata_h:					Handle;
			r_buf, g_buf, b_buf:		DLinePtr;
			addr:						PLinePtr;
			savePort:					GrafPtr;
			myPort:						CGrafPort;
			myProcs:					CQDProcs;
			fakePICT:					PicHandle;
			pm, savePix:				PixMapHandle;
			ct:							CTabHandle;
			bm:							BitMap;
			saveGDevice:				GDHandle;
	BEGIN
		{ Get source and destination filenames & vRefNums. }
		where.h:= 100;
		where.v:= 100;
		list[0]:= 'PICT';
		SFGetFile(where, '', NIL, 1, list, NIL, reply);
		IF NOT reply.good THEN
			EXIT(PICTToDump);
		srcName:= reply.fName;
		err:= GetWDInfo(reply.vRefNum, srcVol, srcDir, dummyL);
		
		GetIndString(s, 128, 2);
		SFPutFile(where, s, concat(reply.fName, '.dis'), NIL, reply);
		IF NOT reply.good THEN
			EXIT(PICTToDump);
		dstName:= reply.fName;
		err:= GetWDInfo(reply.vRefNum, dstVol, dstDir, dummyL);
		SetCursor(watch);
		
		{ Get image size and allocate pixmap and line buffers. }
		IF HOpen(srcVol, srcDir, srcName, fsRdPerm, PICT_File) <> noErr THEN
			BEGIN
				SysBeep(10);
				SetCursor(arrow);
				EXIT(PICTToDump)
			END;
		err:= SetFPos(PICT_File, fsFromStart, 514);
		count:= 8;
		err:= FSRead(PICT_File, count, @picBounds);
		width:= picBounds.right - picBounds.left;
		height:= picBounds.bottom - picBounds.top;
		pixdata_h:= DPNewHandle(LONGINT(width) * height * 4);
		IF pixdata_h = NIL THEN
			BEGIN
				err:= FSClose(PICT_File);
				SysBeep(10);
				SetCursor(arrow);
				EXIT(PICTToDump)
			END;
		pixdata:= pixdata_h^;
		
		{ Set up QuickDraw PixMap data structure. }
		pm:= NewPixMap;
		DisposCTable(pm^^.pmTable);
		ct:= CTabHandle(NewHandle(SIZEOF(ColorTable)));
		WITH ct^^ DO
			BEGIN
				ctSeed:= 24;
				ctFlags:= 0;
				ctSize:= 0
			END;
		WITH pm^^ DO
			BEGIN
				pmTable:= ct;
				baseAddr:= pixdata;
				rowBytes:= BOR(LONGINT(width) * 4, $8000);
				bounds:= picBounds;
				pmVersion:= 0;
				packType:= 0;
				packSize:= 0;
				pixelType:= RGBDirect;
				pixelSize:= 32;
				cmpCount:= 3;
				cmpSize:= 8;
				planeBytes:= 0;
				pmReserved:= 0
			END;
		bm.baseAddr:= Ptr(pm);
		bm.rowBytes:= $C000;

		{ Setup offscreen GDevice, GrafPort and Pixmap. }
		HLock(Handle(myGDevice));
		WITH myGDevice^^ DO
			BEGIN
				gdRect:= picBounds;
				WITH gdPMap^^ DO
					BEGIN
						baseAddr:= pixdata;
						rowBytes:= pm^^.rowBytes;
						bounds:= picBounds
					END
			END;
		HUnlock(Handle(myGDevice));
		saveGDevice:= GetGDevice;
		SetGDevice(myGDevice);
		
		GetPort(savePort);
		OpenCPort(@myPort);
		SetPort(@myPort);
		savePix:= myPort.portPixMap;
		SetPortPix(pm);
		SetStdCProcs(myProcs);
		myProcs.getPicProc:= @GetPICTData;
		myPort.grafProcs:= @myProcs;
		RectRgn(myPort.visRgn, picBounds);
		myPort.portRect:= picBounds;
		ClipRect(picBounds);
		fakePICT:= PicHandle(NewHandle(SIZEOF(Picture)));
		err:= SetFPos(PICT_File, fsFromStart, 512);
		count:= SIZEOF(Picture);
		HLock(Handle(fakePICT));
		err:= FSRead(PICT_File, count, Ptr(fakePICT^));
		
		{ Spool! }
		spoolErr:= noErr;
		DrawPicture(fakePICT, fakePICT^^.picFrame);
		
		{ Clean up spooling stuff. }
		SetGDevice(saveGDevice);
		err:= FSClose(PICT_File);
		myPort.grafProcs:= NIL;
		SetPortPix(savePix);
		CloseCPort(@myPort);
		DisposHandle(Handle(fakePICT));
		SetPort(savePort);
		DisposPixMap(pm);
		IF spoolErr <> noErr THEN
			BEGIN
				DPDisposHandle(pixdata_h);
				SysBeep(10);
				SetCursor(arrow);
				EXIT(PICTToDump)
			END;
		
		{ Create & prepare Dump file. }
		err:= HDelete(dstVol, dstDir, dstName);
		err:= HCreate(dstVol, dstDir, dstName, OSType(0), OSType(0));
		err:= HOpen(dstVol, dstDir, dstName, fsWrPerm, dFile);
		IF err <> noErr THEN
			BEGIN
				DPDisposHandle(pixdata_h);
				SysBeep(10);
				SetCursor(arrow);
				EXIT(PICTToDump)
			END;
		r_buf:= DLinePtr(NewPtr(width));
		g_buf:= DLinePtr(NewPtr(width));
		b_buf:= DLinePtr(NewPtr(width));
		err:= WriteWord(dFile, width);
		err:= WriteWord(dFile, height);
		len1:= 4;
		
		{ Write pixmap to file. }
		FOR line:= 0 TO height - 1 DO
			BEGIN
				err:= WriteWord(dFile, line);
				addr:= PLinePtr(LONGINT(pixdata) + LONGINT(width) * 4 * line);
				{$PUSH}
				{$R-}
				FOR i:= 0 TO width - 1 DO
					WITH addr^[i] DO
						BEGIN
							r_buf^[i]:= r;
							g_buf^[i]:= g;
							b_buf^[i]:= b
						END;
				{$POP}
				count:= width;
				err:= FSWrite(dFile, count, Ptr(r_buf));
				count:= width;
				err:= FSWrite(dFile, count, Ptr(g_buf));
				count:= width;
				err:= FSWrite(dFile, count, Ptr(b_buf));
				len1:= len1 + 3 * width + 2
			END;
		
		{ Clean up Dump file stuff. }
		err:= GetEOF(dFile, len2);
		err:= FSClose(dFile);
		IF len1 <> len2 THEN
			BEGIN
				SysBeep(10);
				err:= HDelete(dstVol, dstDir, dstName)
			END;
		DisposPtr(Ptr(r_buf));
		DisposPtr(Ptr(g_buf));
		DisposPtr(Ptr(b_buf));
		DPDisposHandle(pixdata_h);
		SetCursor(arrow)
	END;
	
	PROCEDURE Quit;
	BEGIN
		DisposGDevice(myGDevice);
		ExitToShell
	END;
	
	PROCEDURE DoCommand(menuResult: LONGINT);
		VAR
			theMenu, theItem, dummyI:	INTEGER;
			name:						Str255;
			refNum:						INTEGER;
			dummyB:						BOOLEAN;
	BEGIN
		{ Command dispatcher; called to handle menu selections. }
		theMenu := HiWrd(menuResult);
		theItem := LoWrd(menuResult);
		CASE theMenu OF
	
			appleMenu:
				IF theItem = aboutItem THEN
					dummyI:= Alert(128, NIL)
				ELSE
					BEGIN
						{ Open DA. }
						GetItem(myMenus[appleMenu], theItem, name);
						refNum:= OpenDeskAcc(name)
					END;
	
			fileMenu:
				CASE theItem OF
					d2pItem:	DumpToPICT;
					p2dItem:	PICTToDump;
					quitItem:	Quit
				END;
	
			editMenu:
				{ Pass edit commands to DAs. }
				dummyB:= SystemEdit(theItem - 1)
		END;
		HiliteMenu(0)
	END;
	
	PROCEDURE DoMouseDown;
		VAR
			code:			INTEGER;
			whichWindow:	WindowPtr;
	BEGIN
		{ MouseDown event handler; only needs to handle menus and DAs. }
		code:= FindWindow(myEvent.where, whichWindow);
		CASE code OF
			inMenuBar:
				DoCommand(MenuSelect(myEvent.where));
			inSysWindow:
				SystemClick(myEvent, whichWindow);
		END
	END;
	
	PROCEDURE DoKeyDown;
	BEGIN
		{ KeyDown event handler; just checks for menu shortcuts. }
		IF BAND(myEvent.modifiers, cmdKey) <> 0 THEN
			DoCommand(MenuKey(chr(BAND(myEvent.message, charCodeMask))))
	END;
	
BEGIN
	Initialize;
	WHILE TRUE DO
		BEGIN
			{ Main event loop. }
			dummyB:= WaitNextEvent(everyEvent, myEvent, 0, NIL);
			CASE myEvent.what OF
				mouseDown:	DoMouseDown;
				keyDown:	DoKeyDown;
				app4Evt:	SetCursor(arrow)
			END
		END
END.
